% d,X,Y,v1,sigma1,v2,sigma2,v3,sigma3
clear vars
data = csvread('hvezdy_Bartko2.csv', 1);

% data = data(1:5, :);

% v = data(:,[4,6,8]);
% sigma = data(:, [5,7,9]);
% N = length(data);

% ==== urceni smeru obehu ====

% pozice a rychlosti ze zadani
position=data(:,2:3);
vel3D=data(:,4:2:8);
vx=vel3D(:,1); %pomocna pro kratsi zapisy dale
sigma = data(:, [5,7,9]);
N = length(data);


           % Construct a questdlg with two SPAD options
                choice = questdlg(['Ktery smer rotace hvezd vybrat?'], ...
                 	'Vbr smru', ...
                	'CW', ...
                    'CCW', ...
                    'oba smry', ...
                    'oba smry');
                % Handle response
                switch choice
                    case 'CW'
                        %velikost rychlosti v^2=vx^2+vy^2
                        vel_amp=sqrt(vel3D(:,1).^2+vel3D(:,2).^2);
                        %smer rychlosti vuci kladne x ose phi=arctg(y/x)
                        vel_ang=atan(vel3D(:,2)./vel3D(:,1));
                        %y=kx+q tecna rychlosti - zjistim q (pozici y na primce x=0 - pokud 'pod'
                        %hvezdou a vx vpravo nebo nad hvezdou a vx vlevo, obiha CCW, pokud opacne,
                        %tak obiha CW
                        q=position(:,2)-position(:,1).*tan(vel_ang);
                        %pokud nejaka tecna protina pocatek (cernou diru), upozorni
                        if (~isempty(find(q==0, 1))) 
                            warndlg(sprintf('spatne urceno pro hvezdu v poradi cislo: %i\r\n', find(q==0)))
                        end

                        %vysledek CW a CCW
                        CW=(q<0&vx>0)|(q>0&vx<0);
                        selected=CW;
                        selected_ind=find(CW)';
                    case 'CCW'
                        %velikost rychlosti v^2=vx^2+vy^2
                        vel_amp=sqrt(vel3D(:,1).^2+vel3D(:,2).^2);
                        %smer rychlosti vuci kladne x ose phi=arctg(y/x)
                        vel_ang=atan(vel3D(:,2)./vel3D(:,1));
                        %y=kx+q tecna rychlosti - zjistim q (pozici y na primce x=0 - pokud 'pod'
                        %hvezdou a vx vpravo nebo nad hvezdou a vx vlevo, obiha CCW, pokud opacne,
                        %tak obiha CW
                        q=position(:,2)-position(:,1).*tan(vel_ang);
                        %pokud nejaka tecna protina pocatek (cernou diru), upozorni
                        if (~isempty(find(q==0, 1))) 
                            warndlg(sprintf('spatne urceno pro hvezdu v poradi cislo: %i\r\n', find(q==0)))
                        end

                        %vysledek CW a CCW
                        CCW=(q<0&vx<0)|(q>0&vx>0);
                        selected=CCW;
                        selected_ind=find(CCW)';
                    case 'oba smry'
                        zahodit=vel3D(:,1)==0|vel3D(:,2)==0|vel3D(:,3)==0;
                        selected=~zahodit; %vsehcny krome 'zahodit'
                        selected_ind=find(selected);
                end

%1e3 nahodnych jednotkovych vektoru
pocet=1e5; %1e3 prepis na jaky pocet chces
vectors=randn(pocet,3);
unitvectors=vectors./repmat(sqrt(vectors(:,1).^2+vectors(:,2).^2+vectors(:,3).^2),1,3);

%vzorecek dle papiru pro vsechny vygenerovane vektory
chi_sq=zeros(pocet,1);
NumOfStars=chi_sq;
stars=cell(pocet,1); %inicializovat struct, ve ktere se budou zaznamenavat hvezdy v prubehu scitani (pr. ze to secetlo hvezdy v poradi 5, 31, 17 ... 88 a konec, narazilo to na limit)
for i=1:pocet
    counter=1; %pocitadlo sectenych hvezd
    n = unitvectors(i,:); %aktualni zkouseny vektor
    A = (vel3D(selected,:)*n').^2; %numerator
    B = ((n*(sigma(selected,:))').^2)'; %denominator
    reduced=A./B; %redukovana hodnota chisq (nenormalizovana)
    [~, ind] = sort(reduced); %seradit od min k max
    chi_sq_n = 1/(N-1)*reduced; %spocist skutecne chisq (jednotlive scitance zatim)
    %pro vsechny hvezdy scitat jednotlive chisq scitance od nejmensiho po
    %nejvetsi, dokud neni dosazeno hodnoty 0,67 -> pak skoncit a jit na
    %dalsi vektor
    chi_sq(i)=reduced(ind(1)); %prvni prvek sumy
    star_log=zeros(sum(selected),1); %prubeh scitani hvezd v aktualni iteraci
    star_log(1)=ind(1); %hvezda s nejmensim rpispevkem k vektoru
    for j=2:length(A) 
        counter=counter+1;
        chi_sq(i)=1/(counter-1)*(chi_sq(i)+reduced(ind(j))); %k predchozi sume pricist vzdy novy N-ty prvek
        star_log(j)=ind(j);
        if chi_sq(i)>0.67
            NumOfStars(i)=counter-1; %pocet sectenych, ktery je mensi nez 0.67
            star_log(star_log==0)=[]; %vsechny nadbytecne prvky pole smazat
            stars{i}=star_log; %ulozit aktualni poradi scitanych hvezd pro i-ty vektor
            clear counter
            break;
        elseif counter==sum(selected) %kdyz secte vsechny hvezdy v setu, ale neprekroci limit, zaznamenat, ze secetl vsechny
            NumOfStars(i)=counter; 
            stars{i}=star_log; %ulozit vsechny hvezdy v poradi od nejmensiho po nejvetsi prispevek
        else
            chi_sq(i)=chi_sq(i)/(1/(counter-1)); %pokud suma nepresahla 0.67, tak od-normalizovat
        end
    end
end

%vektory, co secetly maximum hvezd a kolik to je hvezd
value=max(NumOfStars);
index=find(NumOfStars==value);
%index2=find(NumOfStars==20);
%index=[index' index2']';
closest_vectors=unitvectors(index,:);
summed_stars_ind=cell2mat(stars(index)')';
summed_stars=selected_ind(summed_stars_ind);

%vektory, co secetly o 1 hvezdu min
index_2=find(NumOfStars==value-1);
closest_vectors_2=unitvectors(index_2,:);
summed_stars_ind_2=cell2mat(stars(index_2)')';
summed_stars_2=selected_ind(summed_stars_ind_2);
index_3=[index' index_2']';
closest_vectors_3=unitvectors(index_3,:);
for ii=1:length(index_2)
    stars{index_2(ii)}=[1+stars{index_2(ii)}' nan(1)]';
end
summed_stars_ind3=cell2mat(stars(index_3)')';
% summed_stars3=selected_ind(summed_stars_ind3);

%najdi, ktere hvezdy to scita
sorted=sort(reshape(summed_stars, 1, []));
unique_stars=[sorted(logical(diff(sorted))) sorted(end)];

sorted=sort(reshape(summed_stars_2, 1, []));
unique_stars_2=[sorted(logical(diff(sorted))) sorted(end)];

str2=sprintf('scitane hvezdy pomoci closest_vectors:\r\n');
str3=sprintf('%02.0f: %03.0f\r\n', [(1:length(unique_stars))' (unique_stars)']');
msgbox([str2 str3])

str2=sprintf('scitane hvezdy pomoci closest_vectors_2:\r\n');
str3=sprintf('%02.0f: %03.0f\r\n', [(1:length(unique_stars_2))' (unique_stars_2)']');
msgbox([str2 str3])

%ty vektory, co jdou opacnym smerem, otoc o 180 
%POZOR!!! pro jiny set hvezd vyjdou vektory jinak a urceni podle kladnosti
%a zapornosti X souradnice nebude platit!!!!
closest_vectors(closest_vectors(:,2)<0,:)=closest_vectors(closest_vectors(:,2)<0,:)*(-1);
closest_vectors_2(closest_vectors_2(:,2)<0,:)=closest_vectors_2(closest_vectors_2(:,2)<0,:)*(-1);
closest_vectors_3(closest_vectors_3(:,1)<0,:)=closest_vectors_3(closest_vectors_3(:,1)<0,:)*(-1);
closest_vect=(mean(closest_vectors))/norm((mean(closest_vectors)));
closest_vect3=(mean(closest_vectors_3))/norm((mean(closest_vectors_3)));

%spocteni uhlu theta (uhel od osy +z)
theta = acos(dot(closest_vectors',repmat([0 0 1], length(closest_vectors), 1)') / (1 * 1));
theta_2 = acos(dot(closest_vectors_2',repmat([0 0 1], length(closest_vectors_2), 1)') / (1 * 1));
% smerodatne odchylky vsech uhlu theta a theta_2
span = (max(theta)-min(theta))*180/pi;
span_2 = (max(theta_2)-min(theta_2))*180/pi;
smodch = std(theta);
smodch_2 = std(theta_2);
%zobrazit vystup
uiwait(msgbox(sprintf('Prumerny uhel theta+/-smodch pro nejblizsi vektory je %5.2f +/- %5.2f deg.\r\nPrumerny uhel theta+/-smodch pro druhe nejblizsi vektory je %5.2f +/- %5.2f deg.', mean(theta)*180/pi, span/2, mean(theta_2)*180/pi, span_2/2)));

% rodrigues_rot(closest_vectors, repmat(), phi)

%zobrazit 2D a 3D pohled na vektory
figure('position', [100 100 1200 500])
subplot(1,2,1);
% ax=gca;
% ax.PlotBoxAspectRatio = [1 1 1];
plotv(closest_vectors', 'b')
hold on
plotv(closest_vectors_2', 'r')
hold off
xlabel('x')
ylabel('y')
axis([0 1 0 1])
subplot(1,2,2)
zers=zeros(length(closest_vectors(:,1)),1);
quiver3( zers, zers, zers, closest_vectors(:,1), closest_vectors(:,2), closest_vectors(:,3), 'b', 'Linewidth', 2)
hold on
zers=zeros(length(closest_vectors_2(:,1)),1);
quiver3( zers, zers, zers, closest_vectors_2(:,1), closest_vectors_2(:,2), closest_vectors_2(:,3), 'r', 'Linewidth', 2)
hold off
%axis([0 1 0 1 0 1])
xlabel('x')
ylabel('y')
zlabel('z')

% opakovat postup pro ziskani ID hvezd sectenych prumernym vektorem
    counter=1;
    n = closest_vect; %aktualni zkouseny vektor
    A = (vel3D(selected,:)*n').^2; %numerator
    B = ((n*(sigma(selected,:))').^2)'; %denominator
    reduced=A./B; %redukovana hodnota chisq (nenormalizovana)
    [~, ind] = sort(reduced); %seradit od min k max
    chi_sq_n = 1/(N-1)*reduced; %spocist skutecne chisq (jednotlive scitance zatim)
    %pro vsechny hvezdy scitat jednotlive chisq scitance od nejmensiho po
    %nejvetsi, dokud neni dosazeno hodnoty 0,67 -> pak skoncit a jit na
    %dalsi vektor
    chi_sq_best=reduced(ind(1)); %prvni prvek sumy
    star_log_best=zeros(sum(selected),1); %prubeh scitani hvezd v aktualni iteraci
    star_log_best(1)=ind(1); %hvezda s nejmensim rpispevkem k vektoru
    for j=2:length(A) 
        counter=counter+1;
        chi_sq_best=1/(counter-1)*(chi_sq_best+reduced(ind(j))); %k predchozi sume pricist vzdy novy N-ty prvek
        star_log_best(j)=ind(j);
        if chi_sq_best>0.67
            NumOfStars_best=counter-1; %pocet sectenych, ktery je mensi nez 0.67
            star_log_best(star_log_best==0)=[]; %vsechny nadbytecne prvky pole smazat
            clear counter
            break;
        elseif counter==sum(selected) %kdyz secte vsechny hvezdy v setu, ale neprekroci limit, zaznamenat, ze secetl vsechny
            NumOfStars_best=counter; 
        else
            chi_sq_best=chi_sq_best/(1/(counter-1)); %pokud suma nepresahla 0.67, tak od-normalizovat
        end
    end
star_log_best(:)=selected_ind(star_log_best)+1;

%messagebox s vysledkem
switch choice
    case 'CW'
        str=sprintf('Jednotkovy vektor s nejvetsim poctem sectenych hvezd (prumer spocteny v kodu radky cca 104-105): \r\n\r\n(%f, %f, %f).\r\nSecteno %i hvezd.\r\nHvezd CW celkem: %i.\r\n\r\nJednotkovy vektor se souctem o hvezdu mene navic (prumer spocteny v kodu radky cca 104-105): \r\n\r\n(%f, %f, %f).', closest_vect(1), closest_vect(2), closest_vect(3), value, sum(selected), closest_vect3(1), closest_vect3(2), closest_vect3(3));
        uiwait(msgbox(str));
    case 'CCW'
        str=sprintf('Jednotkovy vektor s nejvetsim poctem sectenych hvezd (prumer spocteny v kodu radky cca 104-105): \r\n\r\n(%f, %f, %f).\r\nSecteno %i hvezd.\r\nHvezd CCW celkem: %i.\r\n\r\nJednotkovy vektor se souctem o hvezdu mene navic (prumer spocteny v kodu radky cca 104-105): \r\n\r\n(%f, %f, %f).', closest_vect(1), closest_vect(2), closest_vect(3), value, sum(selected), closest_vect3(1), closest_vect3(2), closest_vect3(3));
        uiwait(msgbox(str));
    case 'oba smry'
        str=sprintf('Jednotkovy vektor s nejvetsim poctem sectenych hvezd (prumer spocteny v kodu radky cca 104-105): \r\n\r\n(%f, %f, %f).\r\nSecteno %i hvezd.\r\nHvezd celkem: %i.\r\n\r\nJednotkovy vektor se souctem o hvezdu mene navic (prumer spocteny v kodu radky cca 104-105): \r\n\r\n(%f, %f, %f).', closest_vect(1), closest_vect(2), closest_vect(3), value, sum(selected), closest_vect3(1), closest_vect3(2), closest_vect3(3));
        uiwait(msgbox(str));
end
% str=sprintf('Jednotkovy vektor s nejvetsim poctem sectenych hvezd (prumer spocteny v kodu radky cca 104-105): \r\n\r\n(%f, %f, %f).\r\nSecteno %i hvezd.\r\nHvezd CW: %i, hvezd CCW: %i.', closest_vect(1), closest_vect(2), closest_vect(3), value, sum(CW), sum(CCW));
% uiwait(msgbox(str));
str2=sprintf('sectene hvezdy v poradi:\r\n');
str3=sprintf('%02.0f: %03.0f\r\n', [(1:length(star_log_best))' (star_log_best)]');
msgbox([str2 str3])

% fprintf('n = (%f, %f, %f)\n', n(1), n(2), n(3));
% fprintf('chi^2 = %f\n', chi_sq);
